//@author: vux
//@help: standard constant shader
//@tags: color
//@credits: 

float4x4 tWVP: WORLDVIEWPROJECTION;
float4x4 tVI : VIEWINVERSE;

Texture2D texture2dSPRITE <string uiname="texture2dSPRITE";>;
Texture2D texture2dXYZ <string uiname="TextureXYZ";>;
float alpha;
float4x4 tTex <string uiname="Texture Transform"; bool uvspace=true; >;

float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };

SamplerState g_samLinear : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

 
cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : VIEWPROJECTION;
	float4x4 tW : WORLD;
};



struct VS_IN
{
    float4 PosWVP: SV_POSITION;	
	float4 PosO : POSITION;
	float2 TexCd : TEXCOORD0;

};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
    float2 TexCd: TEXCOORD0;
};

vs2ps VS(VS_IN input)
{
    vs2ps Out = (vs2ps)0;
	
	//LOADING TEXTURE AS COORDINATES
	float4 pos = texture2dXYZ.SampleLevel(g_samLinear,input.TexCd.xy,0);
    
	
	//I TRIED TO CONTINUE  !!!!!!!!!!!!!!!!!!
	pos = mul(pos, tVI);
	//pos += float4(pos,1);
	
    Out.TexCd = mul(float4(input.TexCd,1,1), tTex).xy;
	
	
	//Out.PosWVP  = mul(float4(pos.xyz,1),mul(tW,tVP));
    //Out.TexCd = mul(input.TexCd, tTex);
	
	
	
    return Out;
}




float4 PS(vs2ps In): SV_Target
{
    float4 col = texture2dSPRITE.Sample(g_samLinear,In.TexCd) * cAmb;
	col.a = alpha;
    return col;
}





technique10 SPRITES
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




